#include "FIVEWIN.CH"
#ifdef __HARBOUR__
   #include "ShlObj.ch"
   #include "OLEDB.ch"
#endif


PROCEDURE MAIN()

   LOCAL oWnd, oMenu

   MENU oMenu
      MENUITEM "&Probar OLE con..."
      MENU
         MENUITEM "&Excel"              ACTION EXCEL97()
         MENUITEM "&Word"               ACTION WORD97()
         MENUITEM "&Internet Explorer"  ACTION IEXPLORER()
         MENUITEM "&Outlook"            ACTION OUTLOOK()
         SEPARATOR
         MENUITEM "&Provocar excepcion" ACTION EXCEPCION()
         SEPARATOR
         MENUITEM "&Salir"              ACTION oWnd:End()
      ENDMENU
      #ifdef __HARBOUR__
      MENUITEM "&Solo 32 bits..."
      MENU
         MENUITEM "&OleDB"              ACTION OLEDB()
         MENUITEM "&ADO"                ACTION ADO()
         MENUITEM "&ShellLink"          ACTION ShellLink()
      ENDMENU
      #endif
   ENDMENU

   DEFINE WINDOW oWnd FROM 0,0 TO 20,70 TITLE "OLE con FW" MENU oMenu
   ACTIVATE WINDOW oWnd MAXIMIZED

   OleUninitialize()

RETURN

//--------------------------------------------------------------------

STATIC PROCEDURE EXCEL97()

   LOCAL oExcel, oHoja

   oExcel := TOleAuto():New( "Excel.Application" )
   //oExcel := TOleAuto():New( "{00024500-0000-0000-C000-000000000046}" )

   oExcel:WorkBooks:Add()

   oHoja := oExcel:Get( "ActiveSheet" )

   oHoja:Cells:Font:Name := "Arial"
   oHoja:Cells:Font:Size := 12

   oHoja:Cells( 3, 1 ):Value := "Texto:"
   oHoja:Cells( 3, 2 ):Value := "Esto es un texto"
   oHoja:Cells( 4, 1 ):Value := "Nmero:"
   oHoja:Cells( 4, 2 ):Set( "NumberFormat", "#.##0,00" )
   oHoja:Cells( 4, 2 ):Value := 1234.50
   oHoja:Cells( 5, 1 ):Value := "Lgico:"
   oHoja:Cells( 5, 2 ):Value := .T.
   oHoja:Cells( 6, 1 ):Value := "Fecha:"
   oHoja:Cells( 6, 2 ):Value := DATE()

   oHoja:Columns( 1 ):Font:Bold := .T.
   oHoja:Columns( 2 ):Set( "HorizontalAlignment", -4152 )  // xlRight

   oHoja:Columns( 1 ):AutoFit()
   oHoja:Columns( 2 ):AutoFit()

   oHoja:Cells( 1, 1 ):Value := "OLE desde FW"
   oHoja:Cells( 1, 1 ):Font:Size := 16
   oHoja:Range( "A1:B1" ):Set( "HorizontalAlignment", 7 )

   oHoja:Cells( 1, 1 ):Select()
   oExcel:Visible := .T.

   oHoja:End()
   oExcel:End()

RETURN

//--------------------------------------------------------------------

STATIC PROCEDURE WORD97()

   LOCAL oWord, oTexto

   oWord:=TOleAuto():New( "Word.Application" )

   oWord:Documents:Add()

   oTexto := oWord:Selection()

   oTexto:Text := "OLE desde FW"+CRLF
   oTexto:Font:Name := "Arial"
   oTexto:Font:Size := 48
   oTexto:Font:Bold := .T.

   oWord:Visible := .T.
   oWord:Set( "WindowState", 1 )  // Maximizado

   oTexto:End()
   oWord:End()

RETURN

//--------------------------------------------------------------------

STATIC PROCEDURE IEXPLORER()

   LOCAL oIE

   oIE:=TOleAuto():New( "InternetExplorer.Application" )

   oIE:Visible := .T.

   oIE:Invoke("Navigate", "http://www.fivetech.com")

   oIE:End()

RETURN

//--------------------------------------------------------------------

STATIC PROCEDURE OUTLOOK()

   LOCAL oOL, oLista, oMail, i

   oOL := TOleAuto():New( "Outlook.Application.9" )

   IF Ole2TxtError() != "S_OK"

      MsgAlert("Outlook 2000 no est disponible.", "Error")

   ELSE

      oMail := oOL:CreateItem( 0 )  // olMailItem

      FOR i := 1 TO 10
         oMail:Recipients:Add( "Contacto" + LTRIM( STR( i, 2 ) ) + ;
               "<contacto" + LTRIM( STR( i, 2 ) ) + "@servidor.com>" )
      NEXT

      oLista := oOL:CreateItem( 7 )  // olDistributionListItem
      oLista:DLName := "Prueba de lista de distribucin"
      oLista:Display( .F. )
      oLista:AddMembers( oMail:Recipients )
      oLista:Save()
      oLista:Close( 0 )

      oMail:End()
      oLista:End()
      oOL:End()

   ENDIF

RETURN

//--------------------------------------------------------------------

STATIC PROCEDURE EXCEPCION()

   LOCAL oWord

   oWord:=TOleAuto():New( "Word.Application" )

   oWord:Documents:Open("Mi documento.doc")

   oWord:Visible := .T.
   oWord:Set( "WindowState", 1 )  // Maximizado

   oWord:End()

RETURN

//--------------------------------------------------------------------

#ifdef __HARBOUR__

STATIC PROCEDURE OLEDB()

   LOCAL hOLEDB, hCS

   hOLEDB := IDBInitialize():Create( "Advantage.OLEDB" )
   MsgInfo( "hOLEDB = "+cValToChar( hOLEDB:hObj )+"  Error="+Ole2TxtError())

   hOLEDB:Initialize()

   hCS := hOLEDB:QueryInterface( IID_IDBCreateSession )
   MsgInfo( "hCS = "+cValToChar( hCS:hObj )+"  Error="+Ole2TxtError())

   //  Lo siento, no tengo NPI de como seguir...
   //  Sorry, I don't know how to continue....

   hCS:Release()

   hOLEDB:Uninitialize()

//--------------------------------------------------------------------

STATIC PROCEDURE ADO()

   LOCAL oCO, oRS, cFieldName
   LOCAL Conn := "Provider=Advantage OLE DB Provider; " + ;
                 "Data Source=.; " + ;
                 "ServerType=ADS_LOCAL_SERVER; TableType=ADS_CDX;"

   oCO := TOleAuto():New( "ADODB.Connection" )

   IF Ole2TxtError() != "S_OK"

      MsgAlert("ADODB no est disponible.", "Error")

   ELSE

      oCO:Open( Conn )

      MsgInfo( "SELECT * FROM prueba" )
      oRS := oCO:Execute("Select * from PRUEBA")
      oRS:MoveFirst()

      DO WHILE .NOT. oRS:Eof()
         cFieldName := oRS:Fields(0):Name
         MsgInfo( cFieldName + ": " + ;
                  cValToChar( oRS:Fields( cFieldName ):Value ) )
         oRS:MoveNext()
      Enddo

      MsgInfo( "Grabar como .XML" )
      IF FILE( "Prueba.xml" )
         FERASE( "Prueba.xml" )
      ENDIF
      oRS:Save( "Prueba.xml", 1)

      oRS:End()
      oCO:End()

   ENDIF

RETURN

//--------------------------------------------------------------------

STATIC PROCEDURE ShellLink()

   LOCAL oSL, oPF, cExeFile := GetModuleFilename( GetInstance() )

   oSL := IShellLink():Create()

   oSL:SetPath( cExeFile )
   oSL:SetWorkingDirectory( cFilePath( cExeFile ) )
   oSL:SetIconLocation( GetSysDir() + "\Shell32.dll", 41 )

   oPF := oSL:QueryInterface( IID_IPersistFile )
   oPF:Save( AnsiToWide( GetDesktopDir() + cFileNoExt( cExeFile ) + ".lnk" ), .T. )
   oPF:Release()

   oSL:Release()

   MsgInfo( "Se ha creado un acceso directo en el escritorio." )

RETURN

#endif

//-------------------------------------------------------------------------
